/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest{}

// AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest struct for AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest
type AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest struct {
	CallbackUrl *string                                                                            `json:"callbackUrl,omitempty"`
	Config      []AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner `json:"config,omitempty"`
}

// NewAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest instantiates a new AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest() *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest {
	this := AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest{}
	return &this
}

// NewAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequestWithDefaults instantiates a new AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequestWithDefaults() *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest {
	this := AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest{}
	return &this
}

// GetCallbackUrl returns the CallbackUrl field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) GetCallbackUrl() string {
	if o == nil || IsNil(o.CallbackUrl) {
		var ret string
		return ret
	}
	return *o.CallbackUrl
}

// GetCallbackUrlOk returns a tuple with the CallbackUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) GetCallbackUrlOk() (*string, bool) {
	if o == nil || IsNil(o.CallbackUrl) {
		return nil, false
	}
	return o.CallbackUrl, true
}

// HasCallbackUrl returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) HasCallbackUrl() bool {
	if o != nil && !IsNil(o.CallbackUrl) {
		return true
	}

	return false
}

// SetCallbackUrl gets a reference to the given string and assigns it to the CallbackUrl field.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) SetCallbackUrl(v string) {
	o.CallbackUrl = &v
}

// GetConfig returns the Config field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) GetConfig() []AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner {
	if o == nil || IsNil(o.Config) {
		var ret []AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner
		return ret
	}
	return o.Config
}

// GetConfigOk returns a tuple with the Config field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) GetConfigOk() ([]AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner, bool) {
	if o == nil || IsNil(o.Config) {
		return nil, false
	}
	return o.Config, true
}

// HasConfig returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) HasConfig() bool {
	if o != nil && !IsNil(o.Config) {
		return true
	}

	return false
}

// SetConfig gets a reference to the given []AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner and assigns it to the Config field.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) SetConfig(v []AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) {
	o.Config = v
}

func (o AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.CallbackUrl) {
		toSerialize["callbackUrl"] = o.CallbackUrl
	}
	if !IsNil(o.Config) {
		toSerialize["config"] = o.Config
	}
	return toSerialize, nil
}

type NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest struct {
	value *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest
	isSet bool
}

func (v NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) Get() *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest {
	return v.value
}

func (v *NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) Set(val *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest(val *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) *NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest {
	return &NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
